# PS3MCA-TOOL v1.5
This is a continuation of the PS3MCA-TOOL 1.4 modified by l_oliveira to add support for arcade magicgate, as well as other cool features like KELF Card Unbinding

# Usage

the sintax of the program is rather simple
```cmd
ps3mca.exe command arguments...
```

The following commands are avaialable:

Command | alternative name | parameters | Purpose | notes
------- | ---------------- | ---------- | ------- | -----
`--mc-info` | `-i` |  | Get memory card information |
`--mc-free` | `-f` |  | Calculate Free Size on card |
`--mc-image-ecc` | `-imgecc` | `<output filepath>` |  Dump memory card page by page with ECC data | 
`--mc-unformat` |  |   | unformat the card | **Harmful to SC2 Conquest cards**
`--mc-format` |  |  | Format the card | **Harmful to SC2 Conquest cards**
`--list` | `-ls` | `<mc path>` |  list contents of directory (use `.` for card root) |
`--extract-file` | `-x` | `<mc filepath> <output filepath>` | pull file from card into the PC | 
`--inject-file` | `-in` | `<input filepath> <mc filepath>`  | put file from the PC into the card | **Harmful to SC2 Conquest cards**
`--make-directory` | `-mkdir` | `<mc path>` | Create folder inside the card | 
`--remove-directory` | `-rmdir` | `<mc path>` | Remove folder from the card | 
`--remove` | `-rm` | `<mc filepath>` | remove file from the card | 
`--file-crosslink` | `-cl` | `<real mc filepath> <dummy mc filepath>` | file crosslinking | **Introduces FS controlled corruption!**, **Harmful to SC2 Conquest cards**
`--content-key` | `-ck` | `<disk kelf filepath>` | Binds KELF file to the card and shows the final Kbit and Kc
`--sign-kelf` | `-k` | `<disk kelf filepath> <card kelf filepath>` | Binds KELF file to the card and writes as a new file
`--unsign-kelf` | `-u` | `<card kelf filepath> <disk kelf filepath>`| Unbinds a KELF from the current memorycard | Needs the memory card connected

> [!NOTE]
> Although we specify wich features are harmful to the conquest cards. ps3mca will refuse to run these commands if a conquest card is identified

# New Features
- Usage of external mg keys instead of Builtin allow the user to change the desired keys on the fly, instead of having several versions of ps3mca around
- Support for detection of the SoulCalibur2 Conquest card: PS3MCA will let you know if card is a conquest card, and will lock you from using features harmful to the card (eg: unformat, format, crosslink, and any filesystem related feature)
- Configurable verbosity: a configurable verbosity level. you can choose to keep ps3mca silent as usual (verbosity 0) or use higher levels to obtain useful information of the process

## example of `ps3mca.ini`
```ini
[ps3mca]
#name of another section inside this file with all the keys...
mgkey=retail
# (integer): verbosity level
verbose=
[retail]
#keys here
[developer]
#keys here
[arcade]
#keys here
[prototype]
#keys here
```

## The keys
> keys will be available under the following names

original name | alternative name (kelftool) | size (bytes)
------------- | --------------------------- | -------------
`MC_CARDKEY_MATERIAL_1` | `MG_CARDIV_0` | 8
`MC_CARDKEY_HASHKEY_1`  | `MG_CARDKEY_0` | 16
`MC_CARDKEY_MATERIAL_2` | `MG_CARDIV2_0` | 8
`MC_CARDKEY_HASHKEY_2`  | `MG_CARDKEY2_0` | 16
`MC_CHALLENGE_MATERIAL` | `MG_CHALLENGE_IV`  | 8
`MG_KBIT_MATERIAL` | `MG_KBIT_IV` | 8
`MG_KC_MATERIAL` | `MG_KC_IV` | 8
`MG_KBIT_MASTER_KEY` | - | 16
`MG_KC_MASTER_KEY` | - | 16

### key value example
lets say a key value is:
```c
uint8_t MC_CARDKEY_MATERIAL_1[8] = {0x00, 0x99, 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xFF}
```
you will write it down on the INI this way:

```ini
MC_CARDKEY_MATERIAL_1=0099AABBCCDDEEFF
```

## Verbosity
Verbosity is handled by a number, the higher it is, the more info you'll get on the log (higher numbers include the logging from smaller numbers)

- 1: minimal logging
- 2: during card auth, log the values of the Memory card `CardIV`, `CardMaterial` and `CardNonce`. also logs kbit and kc encryption values during KELF Binding and un-binding
- 3: during card auth, log the values of mechacon challenges, card challenge responses and session key
- 11: print the keys chosen on the INI

# LIBUSB Library and driver
The recomended driver is https://github.com/mcuee/libusb-win32
the DLL is already bundled (`amd64` dir)
